# C++代码性能优化的方法
 + 使用const关键字
 + 避免频繁进行内存分配和释放
 + 尽量减少值传递，多用引用来传递参数
 + 局部变量VS静态变量（多次调用局部更快，因为局部变量可以读入寄存器，静态不行）
 + ++i和i++的效率问题（使用迭代器可能比使用指针更优：迭代器++i可以减少一次构造和析构）
 + 避免使用多重继承
 + 低级代码使用位运算替代算术运算
 + 使用编译器自带的优化选项
 + 将小粒度函数声明为内联函数（inline）
 + 循环内定义，还是循环外定义对象：由构造函数和复制操作的效率比较决定
 + 小函数放在同一循环内效率高，大函数分开放效率更高（由cpu寄存器决定）
 + 尽量少使用`dynamic_cast`
 + 减少除法运算的使用，除数尽量使用常量，让编译器优化
 + 多用直接初始化
 + 循环展开加速
